import 'wc_dimension.dart';
import 'wp_attribute.dart';
import 'wp_category.dart';
import 'wp_image.dart';
import 'package:lab_rat_storage/lab_rat_storage.dart';
import 'wp_tag.dart';

class WCProduct extends JsonObject {
  int id;
  int parentId;
  List<String> variations;

  String slug;
  String permalink;

  String name;
  String description;
  String short_description;

  String _dateCreated;
  String _dateModified;

  DateTime get dateCreated => DateTime.parse(_dateCreated);
  void set dateCreated(DateTime date) {
    _dateCreated = date.toString();
  }

  DateTime get dateModified => DateTime.parse(_dateModified);
  void set dateModified(DateTime date) {
    _dateModified = date.toString();
  }

  bool purchasable;

  String type;
  String status;
  bool featured;
  bool catalogVisibility;

  int price;
  int regular_price;
  int sale_price;
  bool on_sale;
  String price_html;

  List<int> crossSaleIds;
  List<int> upsaleIds;

  int weight;

  List<WPTag> tags;
  List<WPImage> images;
  List<WPCategory> categories;
  WCDimensions dimensions;
  List<WCAttribute> attributes;

  @override
  void fromJson(target) {
    id = target['id'];
    parentId = target['parent_id'];

    slug = target['slug'];
    permalink = target['permalink'];

    name = target['name'];
    description = target['description'];
    short_description = target['short_description'];

    dateCreated = target['date_created'];
    dateModified = target['date_modified'];

    purchasable = target['purchasable'];

    type = target['type'];
    status = target['status'];
    featured = target['featured'];
    catalogVisibility = target['catalog_visibility'];

    price = target['price'];
    regular_price = target['regular_price'];
    sale_price = target['sale_price'];
    on_sale = target['on_sale'];
    price_html = target['price_html'];

    crossSaleIds = target['cross_sale_ids'];
    upsaleIds = target['upsale_ids'];

    weight = target['weight'];

    tags = [];
    if (target.containsKey('tags'))
      tags = target['tags'].map((x) => new WPTag()..fromJson(x));

    images = [];
    if (target.containsKey('images'))
      images = target['images'].map((x) => new WPImage()..fromJson(x));

    categories = [];
    if (target.containsKey('categories'))
      categories =
          target['categories'].map((x) => new WPCategory()..fromJson(x));

    attributes = [];
    if (target.containsKey('attributes'))
      attributes =
          target['attributes'].map((x) => new WCAttribute()..fromJson(x));

    variations = [];
    if (target.containsKey('variations'))
      variations =
          target['variations'].map((x) => new WCProduct()..fromJson(x));

    dimensions = new WCDimensions()..fromJson(target['dimensions']);
  }
}
